//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon-Suk Lee (jl)
//  FILE: PCPreCond.H
//  PROJ: COKO
//  DATE: 7/28/97
//
// SYNOPSIS
//  Class definition for CPreCond.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCPRECOND_H_
#define _PCPRECOND_H_

#define MAXARG 20
// used for an array that stores all the parser (prolog to kola) that have been
// generated. I couldn't just destruct the parsers after I used them.
// (caused unexpected error (flex and bison error) I could figure it out. 
// It is a bug that needs to be fixed.


#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include <iomanip.h>
#include <fstream.h>
#include <strstream.h>
#include <stdlib.h>
#include <iostream.h>
#include <stdarg.h>
#include "PCCond.H"
#include "PCPattern.H"
#include "PrologParser.H"
#include "CondList.H"
#include "SPPROLOG.H"
//#include "CGlobals.H"


//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CPreCond
//
// SYNOPSIS
//
//////////////////////////////////////////////////////////////////////////////

class CPreCond 
{
protected:

  char* _RuleBlockName;

  int _id;

  CondList* _condList;    
  // condition list
  
public:
  CPreCond(char* a ... );                       
  // Constructor
  
  ~CPreCond();                      
  // Destructor
  
  CState *Exec(CState *, NonType*);
  // What to do when executed

};

#endif
