TRANSFORMATION PD1

 -- Auxiliary transformation called directly by FKAux, 
 -- indirectly by FactorK.  This transformation specifically
 -- simplifies compositions of ITERATE and UNNEST

 USES

   ru1: f o id        --> f,

   ru2:	ITERATE (K (true), f o #2) o UNNEST (h1, h2)     --> ITERATE (K (TRUE), f) o UNNEST (#2 o h1, h2),
   ru3: ITERATE (K (true), #2) o UNNEST (h1, h2)         --> UNNEST (#2 o h1, h2),
   ru4: ITERATE (K (true), f o SHR) o UNNEST (h1, h2)    --> ITERATE (K (TRUE), f) o UNNEST (SHR o h1, h2),
   ru5: ITERATE (K (true), SHR) o UNNEST (h1, h2)        --> UNNEST (SHR o h1, h2),
   ru6: ITERATE (p OPLUS SHR, f o SHR) o UNNEST (h1, h2) --> ITERATE (p, f) o UNNEST (SHR o h1, h2),
   ru7: ITERATE (p OPLUS SHR, SHR) o UNNEST (h1, h2)     --> ITERATE (p, id) o UNNEST (SHR o h1, h2),
   ru8: ITERATE (p OPLUS #2, f o #2) o UNNEST (h1, h2)   --> ITERATE (p, f) o UNNEST (#2 o h1, h2),
   ru9: ITERATE (p OPLUS #2, #2) o UNNEST (h1, h2)       --> ITERATE (p, id) o UNNEST (#2 o h1, h2),
   ru10: ITERATE (p OPLUS #2, f o SHR) o UNNEST (h1, h2) --> ITERATE (p OPLUS #2 OPLUS #2, f) o UNNEST (SHR o h1, h2),
   ru11: ITERATE (p OPLUS #2, SHR) o UNNEST (h1, h2)     --> ITERATE (p OPLUS #2 OPLUS #2, id) o UNNEST (SHR o h1, h2),
   ru12: ITERATE (p OPLUS SHR, f o #2) o UNNEST (h1, h2) --> ITERATE (p, f o #2 o #2) o UNNEST (SHR o h1, h2),
   ru13: ITERATE (p OPLUS SHR, #2) o UNNEST (h1, h2)     --> ITERATE (p, #2 o #2) o UNNEST (SHR o h1, h2),
   LB
 BEGIN   
   {{{ru2 || ru3 || ru5 || ru7 || ru8 || ru9} -> {GIVEN _F o UNNEST (f, _F) DO ru1 (f) || GIVEN UNNEST (f, _F) DO ru1 (f)}} ||
    {{ru4 || ru6 || ru10 || ru11 || ru12 || ru13} -> {GIVEN _F o UNNEST (f, _F) DO {{ru1 (f) || LB (f)}; PD1}}}
   }
 END

