//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl@cs.brown.edu)
//  FILE: PCFalseStmt.H
//  PROJ: COKO
//  DATE: 6/10/97                                                              
//
// SYNOPSIS
//  Class definition for CFalseStmt class.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCFALSESTMT_H_
#define _PCFALSESTMT_H_

#include <PCStmt.H>

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CFalseStmt
//
// SYNOPSIS
//  This class is a derived class from CStmt. 
//  This stmt always returns false as a success value.
//
//////////////////////////////////////////////////////////////////////////////

class CFalseStmt : public CStmt
{
protected:
  CStmt *_stmt;                  
  // statement(s)

public:
  CFalseStmt(CStmt *); 
  // Constructor
  ~CFalseStmt(void);         
  // Destructor
  CState *Exec(CState *); 
  // What to do when executed
};

#endif
