%{
#include <stdlib.h>
#include <string.h>
#include <fstream.h>
//#include <libc.h>
#include "PAParser.h"

extern int CKparse();
extern FILE *CKin;
extern PARuleBlock *theBlock;
extern void fatal(char *, char *);

int compile_type;

// char *commandline = NULL;
char *filenameC, *filenameH, *filenameSLC, *filenameMainC, *filenameMainH, *filenamePL;

static int myinput(char *buf, int max);

#undef YY_INPUT
#define YY_INPUT(buf, result, max) (result = myinput(buf, max))

%}


%%
[^ \n\t\-\+]+".rb"              { 
                       ofstream foutC, foutH, foutSLC, foutMainC, foutMainH, foutPL; 

					   // char *temp;
					   int strlength;

					   if((CKin = fopen(CLtext, "rt")) == NULL) {
                        fatal("Unable to open coko rule block file", CLtext);
					   }

					   if(CKparse() == 0) {
						 strlength = strlen(theBlock->Name()) + strlen(".cc") + 1;
						 filenameC = new char[strlength];
						 sprintf(filenameC, "%s.cc", theBlock->Name());

						 strlength = strlen(theBlock->Name()) + strlen(".h") + 1;
						 filenameH = new char[strlength];
						 sprintf(filenameH, "%s.h", theBlock->Name());

						 strlength = strlen(theBlock->Name()) + strlen("_main.cc") + 1;
						 filenameMainC = new char[strlength];
						 sprintf(filenameMainC, "%s_main.cc", theBlock->Name());

						 strlength = strlen(theBlock->Name()) + strlen("_main.h") + 1;
						 filenameMainH = new char[strlength];
						 sprintf(filenameMainH, "%s_main.h", theBlock->Name());

						 strlength = strlen(theBlock->Name()) + strlen("_sl.cc") + 1;
						 filenameSLC = new char[strlength];
						 sprintf(filenameSLC, "%s_sl.cc", theBlock->Name());

/*
						 strlength = strlen(theBlock->Name()) + strlen("_fin.pl") + 1;
						 filenamePL = new char[strlength];
						 sprintf(filenamePL, "%s_fin.pl", theBlock->Name());
*/

                         if (compile_type == 2)
                         {
						    foutC.open(filenameC);
						    foutH.open(filenameH);
						    /* foutPL.open(filenamePL); */
                         }

						 if (compile_type == 1)
                            foutSLC.open(filenameSLC);

                         if (compile_type == 0)
                         {
                            foutMainC.open(filenameMainC);
                            foutMainH.open(filenameMainH);
                         }

						 theBlock->Emit(foutH, foutC, foutSLC, foutMainC, foutMainH, foutPL, compile_type);

                         if (compile_type == 2)
						 { 
                                                    foutC.close();
						    foutH.close();
						    /* foutPL.close(); */
                         }

						 if (compile_type == 1)
						    foutSLC.close();

                         if (compile_type == 0)
						 { 
                            foutMainC.close();
						    foutMainH.close();
                         }

						 delete filenameH;
						 delete filenameSLC;
						 delete filenameC;
						 delete filenameMainC;
						 delete filenameMainH;
						 /* delete filenamePL; */

						 delete theBlock;
						 theBlock = NULL;
						 filenameC = filenamePL = filenameH = filenameSLC = filenameMainC = filenameMainH = NULL;

					   }
					   else fatal("Parse error in coko rule block file", CLtext);
                     }

[^ \t\n]+            { 
                       // if(commandline == NULL)
                       // commandline = strdup(CLtext);
                       // else {
                       // int strlength = strlen(commandline) + strlen(CLtext) + 2;
                       // char *temp = commandline;
                       // commandline = new char[strlength];
                       // sprintf(commandline, "%s %s", temp, CLtext);
                       // delete temp;
                       // }
                     }
%%
char **targv;
char **arglim;

static unsigned offset = 0;

int
myinput(char *buf, int max)
{
  int len, copylen;
 
  if(targv >= arglim)
	return 0;
  
  len = strlen(*targv) - offset;
  if(len >= max)
	copylen = max - 1;
  else
	copylen = len;
  if(len > 0)
	memcpy(buf, targv[0] + offset, copylen);
  if(targv[0][offset + copylen] == '\0') {
	buf[copylen] = ' ';
	copylen++;
	offset = 0;
	targv++;
  }
  return copylen;
}

int CLwrap() { return 1; }
