//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl)
//  FILE: PCBottomUpStmt.H
//  PROJ: COKO Compiler
//  DATE: 6/14/97
//
// SYNOPSIS
//  Class definitions for CBottomUpStmt.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCBOTTOMUPSTMT_H_
#define _PCBOTTOMUPSTMT_H_

#include "PCStmt.H"
#include "PCChildPattern.H"

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CBottomUpStmt
//
// SYNOPSIS
//  This class is a derived class from CStmt. 
//
//////////////////////////////////////////////////////////////////////////////

class CBottomUpStmt : public CStmt {
protected:

  CStmt *_stmt;                           
    
public:
  CBottomUpStmt(CStmt *);                 
  // Constructor.
  ~CBottomUpStmt(void);                   
  // Destructor.
  CState *Exec(CState *s);
  // What to do when executed.
};

#endif
