//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Kee-Eung Kim (kek), Joon S. Lee (jl)
//
//  FILE: PCStmt.H
//  PROJ: COKO
//  DATE: 5/5/97
//
// SYNOPSIS
//  Class definition for CStmt class.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCSTMT_H_
#define _PCSTMT_H_

#include <stdio.h>
#include <stdlib.h>
#include "PCState.H"
#include "PCPattern.H"

class CState;

extern int _debug_;

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CStmt
//
// SYNOPSIS
//  This class is an abstract base class for rule blocks statements. 
//
//////////////////////////////////////////////////////////////////////////////

class CStmt {
public:
  
  virtual CState *Exec(CState *s) = 0;
  // What to do when executed
  
  virtual ~CStmt() {}                         
  // Destructor (virtual)
  
  virtual CState* updateDEP (char*, CState*, CIEnvStackDataType*, int);
  // updates variable dependancy list

protected:

};
#endif
